/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

/* Time Complexity: O( (S^2 + N*N*S) * big_numbers ) */

#include <stdio.h>
#include <string.h>
#define filein "ship.in"
#define fileout "ship.out"
#define maxs 11
#define maxn 41
#define maxc 60
#define baza 10000
#define fmt "%04ld"
#define fwd 4

typedef long BigNum[maxc];

void add(BigNum,BigNum,BigNum);
void multbig(BigNum,BigNum,BigNum);

void readdata(void);
void precompute(void);
void compute(void);
void writedata(void);

BigNum comb[maxs][maxs],T[maxn][maxn],v,v1;
long n,s;

int main()
{
readdata();
precompute();
compute();
writedata();
return 0;
}

void readdata(void)
{
freopen(filein,"r",stdin);
scanf("%ld %ld",&s,&n);
}

void precompute(void)
{
long i,j;

memset(comb,0,sizeof(comb));
comb[1][0][0]=comb[1][0][1]=comb[1][1][0]=comb[1][1][1]=1;

for (i=2;i<=s;i++)
  {
  comb[i][0][0]=comb[i][0][1]=1;
  for (j=1;j<=i;j++)
    add(comb[i-1][j-1],comb[i-1][j],comb[i][j]);
  }
}

void compute(void)
{
long i,j,k;

memset(T,0,sizeof(T));
for (i=1;i<=s;i++)
  if (i<=n)
    memmove(T[1][i],comb[s][i],sizeof(BigNum));

for (i=2;i<=n;i++)
  for (j=i;j<=i*s && j<=n;j++)
    {
    for (k=j;k>=0 && k>=j-s && j-k<=n-i+1;k--)
      if (T[i-1][k][0]>0) /* T[i-1][k] > 0 */
        {
        multbig(T[i-1][k],comb[s][j-k],v);
        add(v,T[i][j],v1);
        memmove(T[i][j],v1,sizeof(BigNum));
        }
    }
}

void writedata(void)
{
long i;

freopen(fileout,"w",stdout);

printf("%ld",T[n][n][T[n][n][0]]);
for (i=T[n][n][0]-1;i>=1;i--)
  printf(fmt,T[n][n][i]);

printf("\n");
}

void add(BigNum n1,BigNum n2,BigNum rez)
{
long i,ndigits=n1[0];
if (n2[0]>ndigits)
  ndigits=n2[0];

memset(rez,0,sizeof(BigNum));
for (i=1;i<=ndigits;i++)
  rez[i]=n1[i]+n2[i];

for (i=1;i<=(ndigits+fwd);i++)
  if (rez[i]>=baza)
    {
    rez[i+1]+=(rez[i]/baza);
    rez[i]%=baza;
    }

for (i=(ndigits+fwd);i>=1;i--)
  if (rez[i]>0)
    {
    rez[0]=i; break;
    }
}

void multbig(BigNum n1,BigNum n2,BigNum rez)
{
long i,j,ndigits=n1[0]+n2[0]-1;

memset(rez,0,sizeof(BigNum));
for (i=1;i<=n1[0];i++)
  for (j=1;j<=n2[0];j++)
    rez[i+j-1]+=(n1[i]*n2[j]);

for (i=1;i<=(ndigits+fwd);i++)
  if (rez[i]>=baza)
    {
    rez[i+1]+=(rez[i]/baza);
    rez[i]%=baza;
    }

for (i=(ndigits+fwd);i>=1;i--)
  if (rez[i]>0)
    {
    rez[0]=i; break;
    }
}

